From 628e49767812a4124c03b163c46dae0579c40cbd Mon Sep 17 00:00:00 2001
From: Richard Guo <guofenglinux@gmail.com>
Date: Thu, 9 Jul 2026 17:51:10 +0900
Subject: [PATCH v1] Introduce UniqueKeys to track the distinctness of
 relations

Add a UniqueKeys facility that records, for each relation the planner
builds, the sets of expressions over which its output is known to be
distinct.  A RelOptInfo's uniquekeys list holds UniqueKey nodes, each
a set of EquivalenceClasses that no two output rows agree on; an empty
set means the relation emits at most one row.  Expressing keys as
EquivalenceClasses, as pathkeys do, lets a key stand for any member of
the class and keeps the representation compact.

Each UniqueKey also carries a "nullable" flag.  A non-nullable key is
NULL-aware (no two rows are equal even treating NULLs as equal), which
is what justifies removing a DISTINCT or GROUP BY.  A nullable key
guarantees distinctness only among rows whose key expressions are all
non-NULL, which still suffices to prove a join inner-unique or to
match a strict join clause.  Keys are always kept over the base
(un-nulled) EquivalenceClasses; the nullable flag records the effect
of an outer join null-extending a column.

UniqueKeys are deduced bottom-up.  A base relation's keys come from
its unique, immediately enforced, non-partial indexes.  A subquery
inherits the keys already deduced for its own final relation,
translated into the outer query, plus a whole-row key for a non-ALL
set operation.  A join relation's keys are derived from its inputs by
preserving one side's key when the other side is unique for the join
clauses, and by combining a key from each side; an inner join's strict
clauses can strengthen a nullable key back to non-nullable.  Finally
the grouping and DISTINCT steps are distinct over their clause
columns, and steps that neither add nor duplicate rows carry their
input's keys through unchanged.

To bound the bookkeeping, keys are tracked only over ECs that some
consumer could use.  Those consumers are: removing a redundant
DISTINCT or GROUP BY step when the input is already distinct over the
relevant columns; proving a join inner-unique in innerrel_is_unique(),
now including multi-relation inner sides; and skipping the
unique-ification of a semijoin's RHS when it is already distinct.

See src/backend/optimizer/README for a fuller description.
---
 .../expected/pg_stash_advice.out              |   42 +-
 .../postgres_fdw/expected/postgres_fdw.out    |   28 +-
 src/backend/optimizer/README                  |   97 ++
 src/backend/optimizer/path/Makefile           |    3 +-
 src/backend/optimizer/path/allpaths.c         |   39 +
 src/backend/optimizer/path/equivclass.c       |    8 +-
 src/backend/optimizer/path/meson.build        |    1 +
 src/backend/optimizer/path/pathkeys.c         |    3 +-
 src/backend/optimizer/path/uniquekeys.c       | 1296 +++++++++++++++++
 src/backend/optimizer/plan/analyzejoins.c     |   18 +-
 src/backend/optimizer/plan/planner.c          |  150 +-
 src/backend/optimizer/util/relnode.c          |    5 +
 src/include/nodes/pathnodes.h                 |   42 +
 src/include/optimizer/paths.h                 |   38 +-
 src/test/regress/expected/aggregates.out      |   49 +-
 src/test/regress/expected/join.out            |   39 +-
 src/test/regress/expected/uniquekeys.out      |  354 +++++
 src/test/regress/parallel_schedule            |    2 +
 src/test/regress/sql/aggregates.sql           |   24 +-
 src/test/regress/sql/uniquekeys.sql           |  118 ++
 src/tools/pgindent/typedefs.list              |    1 +
 21 files changed, 2235 insertions(+), 122 deletions(-)
 create mode 100644 src/backend/optimizer/path/uniquekeys.c
 create mode 100644 src/test/regress/expected/uniquekeys.out
 create mode 100644 src/test/regress/sql/uniquekeys.sql

diff --git a/src/backend/optimizer/path/Makefile b/src/backend/optimizer/path/Makefile
index 1e199ff66f7..7b9820c25f3 100644
--- a/src/backend/optimizer/path/Makefile
+++ b/src/backend/optimizer/path/Makefile
@@ -21,6 +21,7 @@ OBJS = \
 	joinpath.o \
 	joinrels.o \
 	pathkeys.o \
-	tidpath.o
+	tidpath.o \
+	uniquekeys.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 9c040ecefc8..4b3fda0fc46 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -95,6 +95,7 @@ join_search_hook_type join_search_hook = NULL;
 static void set_base_rel_consider_startup(PlannerInfo *root);
 static void set_base_rel_sizes(PlannerInfo *root);
 static void setup_simple_grouped_rels(PlannerInfo *root);
+static void set_base_rel_uniquekeys(PlannerInfo *root);
 static void set_base_rel_pathlists(PlannerInfo *root);
 static void set_rel_size(PlannerInfo *root, RelOptInfo *rel,
 						 Index rti, RangeTblEntry *rte);
@@ -200,6 +201,11 @@ make_one_rel(PlannerInfo *root, List *joinlist)
 	 */
 	setup_simple_grouped_rels(root);
 
+	/*
+	 * Deduce the base rels' unique keys before the join search uses them.
+	 */
+	set_base_rel_uniquekeys(root);
+
 	/*
 	 * We should now have size estimates for every actual table involved in
 	 * the query, and we also know which if any have been deleted from the
@@ -374,6 +380,39 @@ setup_simple_grouped_rels(PlannerInfo *root)
 	}
 }
 
+/*
+ * set_base_rel_uniquekeys
+ *	  Deduce the unique keys of each base relation's output.
+ *
+ * This needs to be done after EquivalenceClass merging and the EC-mutating
+ * steps (such as join removal) are complete, and after subqueries in FROM
+ * have been planned, since a subquery RTE's keys are translated from its
+ * final relation's uniquekeys.  It must run before the join search starts,
+ * which derives join relations' keys from the base rels'.
+ */
+static void
+set_base_rel_uniquekeys(PlannerInfo *root)
+{
+	Index		rti;
+
+	for (rti = 1; rti < root->simple_rel_array_size; rti++)
+	{
+		RelOptInfo *rel = root->simple_rel_array[rti];
+
+		/* there may be empty slots corresponding to non-baserel RTEs */
+		if (rel == NULL)
+			continue;
+
+		Assert(rel->relid == rti);	/* sanity check on array */
+
+		/* ignore RTEs that are "other rels" */
+		if (rel->reloptkind != RELOPT_BASEREL)
+			continue;
+
+		populate_baserel_uniquekeys(root, rel);
+	}
+}
+
 /*
  * set_base_rel_pathlists
  *	  Finds all paths available for scanning each base-relation entry.
diff --git a/src/backend/optimizer/path/equivclass.c b/src/backend/optimizer/path/equivclass.c
index e3697df51a2..cf808a14910 100644
--- a/src/backend/optimizer/path/equivclass.c
+++ b/src/backend/optimizer/path/equivclass.c
@@ -495,6 +495,7 @@ process_equivalence(PlannerInfo *root,
 		ec->ec_min_security = restrictinfo->security_level;
 		ec->ec_max_security = restrictinfo->security_level;
 		ec->ec_merged = NULL;
+		/* ec_index is set later */
 		em1 = add_eq_member(ec, item1, item1_relids,
 							jdomain, item1_type);
 		em2 = add_eq_member(ec, item2, item2_relids,
@@ -863,6 +864,7 @@ get_eclass_for_sort_expr(PlannerInfo *root,
 		}
 	}
 
+	newec->ec_index = list_length(root->eq_classes);
 	root->eq_classes = lappend(root->eq_classes, newec);
 
 	/*
@@ -871,7 +873,6 @@ get_eclass_for_sort_expr(PlannerInfo *root,
 	 */
 	if (root->ec_merging_done)
 	{
-		int			ec_index = list_length(root->eq_classes) - 1;
 		int			i = -1;
 
 		while ((i = bms_next_member(newec->ec_relids, i)) > 0)
@@ -891,7 +892,7 @@ get_eclass_for_sort_expr(PlannerInfo *root,
 			Assert(rel->reloptkind == RELOPT_BASEREL);
 
 			rel->eclass_indexes = bms_add_member(rel->eclass_indexes,
-												 ec_index);
+												 newec->ec_index);
 		}
 	}
 
@@ -1208,6 +1209,9 @@ generate_base_implied_equalities(PlannerInfo *root)
 		Assert(ec->ec_merged == NULL);	/* else shouldn't be in list */
 		Assert(!ec->ec_broken); /* not yet anyway... */
 
+		/* The EC's position is now final, since no more merging can happen */
+		ec->ec_index = ec_index;
+
 		/*
 		 * Generate implied equalities that are restriction clauses.
 		 * Single-member ECs won't generate any deductions, either here or at
diff --git a/src/backend/optimizer/path/meson.build b/src/backend/optimizer/path/meson.build
index 98f3ebd5192..7d480656ce6 100644
--- a/src/backend/optimizer/path/meson.build
+++ b/src/backend/optimizer/path/meson.build
@@ -10,4 +10,5 @@ backend_sources += files(
   'joinrels.c',
   'pathkeys.c',
   'tidpath.c',
+  'uniquekeys.c',
 )
diff --git a/src/backend/optimizer/path/pathkeys.c b/src/backend/optimizer/path/pathkeys.c
index 5eb71635d15..eac8d029ddf 100644
--- a/src/backend/optimizer/path/pathkeys.c
+++ b/src/backend/optimizer/path/pathkeys.c
@@ -35,7 +35,6 @@ static bool pathkey_is_redundant(PathKey *new_pathkey, List *pathkeys);
 static bool matches_boolean_partition_clause(RestrictInfo *rinfo,
 											 RelOptInfo *partrel,
 											 int partkeycol);
-static Var *find_var_for_subquery_tle(RelOptInfo *rel, TargetEntry *tle);
 static bool right_merge_direction(PlannerInfo *root, PathKey *pathkey);
 
 
@@ -1248,7 +1247,7 @@ convert_subquery_pathkeys(PlannerInfo *root, RelOptInfo *rel,
  * We need this to ensure that we don't return pathkeys describing values
  * that are unavailable above the level of the subquery scan.
  */
-static Var *
+Var *
 find_var_for_subquery_tle(RelOptInfo *rel, TargetEntry *tle)
 {
 	ListCell   *lc;
